/*
 * HorseProgress.java
 *
 * Created on 13 �ԧ�Ҥ� 2549, 19:16 �.
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package horserace;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JProgressBar;
import javax.swing.Timer;

/**
 *
 * @author Administrator
 */
public class HorseProgress extends JProgressBar implements Horse {
   
	private int position = 0;
    private int speed = 10;
    private int priority;
    private Timer timer;
    private Thread thread;
    private String name;
    private volatile boolean isDone = false;
    private volatile boolean pause = true;
    private HorseStateListener listener;


    public HorseProgress(String name) {
    	this(name,null);
    }

    public HorseProgress(String name, HorseStateListener listener) {
        	setTimer();
            setMaximum(1000);
            this.name = name;
            this.listener = listener;
            
	}

    // class Timer เอาไว้ตั้งเวลาเพื่อ update ค่าจาก thread ไปที่ progress bar 
    // พี่เขียนไว้ให้พร้อมใช้งานแล้ว ถ้าสนใจให้อ่าน javadoc เพิ่มเติม
    
    // สมบูรณ์แล้ว
    private void setTimer() {
        timer = new Timer(50, new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                setValue(getPosition());
                repaint();
                if (isDone()) {
                    timer.stop();
                }
            }
        });
    }

    public void run() {
    	// ทำต่อเองนะ
    }

    public int getPosition() {
        return position;
    }

    public void setPosition(int position) {
        this.position = position;
    }

    public int getSpeed() {
        return speed;
    }

    public void setSpeed(int speed) {
        this.speed = speed;
    }

    //สมบูรณ์แล้ว พร้อมตัวช่วยบอกใบ้
    public void start(){
    	pause = false;
    	firedStateChange(Horse.RUN_STATE);
        if(thread == null||!(isDone()||thread.isAlive())){
            timer.start();            
            thread = new Thread(this,name);
            thread.setPriority(this.priority);
            thread.start();
        }
    }

    public void reset(){
    	// reset ต้องทำยังไง?        
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getJockeySkill() {
        return this.priority;
    }

    public void setJockeySkill(int priority) {
    	this.priority = priority;
    }

    public boolean isDone() {
        return isDone;
    }


    // ให้ใช้ความรู้ที่ได้จากการศึกษา Swing Event Handling ในการเรียกใช้งาน
    // เพื่อรายงานผลการเปลี่ยนสถานะต่างๆ ของ progress bar ไปยังวัตถุที่สนใจ
    // อ่าน Observer Pattern ที่ได้อธิบายเพิ่มเติมไปแล้ว
    // method นี้สมบูรณ์แล้ว แต่ยังขาดการเรียกใช้จากภายในคลาส ซึ่งต้องการให้นิสิตเป็นผู้แก้ปัญหา
    // เพื่อต่อให้ตรรกะของ pattern นี้สมบูรณ์
    
    //สมบูรณ์แล้ว    
    private void firedStateChange(int state) {
    	if(listener != null)
    		listener.stateChanged(this,state);
	}

	public void togglePlayPause(){
		pause = !pause;
    }

	@Override
	public void removeStateChangeListener() {
		this.listener = null;
	}

	@Override
	public void setStateChangeListener(HorseStateListener listener) {
		this.listener = listener;
	}

	@Override
	public boolean isPause() {
		return pause;
	}
	


}
