
package horserace;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import com.sun.java.swing.plaf.windows.WindowsLookAndFeel;

import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;


public class HorseRaceFrame extends javax.swing.JFrame implements
		HorseStateListener {

	public HorseRaceFrame() {
		initComponents();
	}

	private void initComponents() {
		horsePanel1 = new HorsePanel("Norm 220",220,5,   this);		
		horsePanel2 = new HorsePanel("Max 200", 220, 10, this);
		horsePanel3 = new HorsePanel("Min 300", 300, 1, this);

		startAllButton = new JButton();
		resetAllButton = new JButton();
		togglePlayPauseButton = new JButton();
		consoleTexAreaScrollPane = new JScrollPane();
		consoleTextArea = new JTextArea();

		setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

		startAllButton.setText("start All");
		startAllButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				startAllActionPerformed(evt);
			}
		});

		resetAllButton.setText("reset All");
		resetAllButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				resetAllActionPerformed(evt);
			}
		});

		togglePlayPauseButton.setText("play / pause All");
		togglePlayPauseButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				togglePlayPauseAllActionPerformed(evt);
			}
		});

		consoleTextArea.setColumns(20);
		consoleTextArea.setRows(5);
		consoleTexAreaScrollPane.setViewportView(consoleTextArea);

		JTextAreaPrintStream jos = new JTextAreaPrintStream(consoleTextArea,
				System.out);
		System.setOut(jos);
		
		/*
		 *  พี่ขึ้นโครงไว้ให้แล้ว เขียนเพื่อ init component ที่เหลือต่อตรงนี้
		 * 
		 * 
		 * 
		 * 
		 * 
		 * 
		 * 
		 * 
		 */
		
		
		pack();
	}

	private void togglePlayPauseAllActionPerformed(ActionEvent evt) {
		// ทำต่อให้จบ
	}

	private void resetAllActionPerformed(ActionEvent evt) {
		// ทำต่อให้จบ
	}

	private void startAllActionPerformed(ActionEvent evt) {
		// ทำต่อให้จบ
	}

	
	/*
	 * ใช้เทคนิกที่ได้จากการเรียนรู้ Swing Event Handling มาสร้าง event handling ของตัวเอง
	 * เพื่อรับค่าการเปลี่ยนแปลงของ state ภายใน thread
	 * 
	 * ให้ศึกษา Observer Pattern ที่อธิบายเพิ่มเติมไปแล้ว
	 */
	@Override
	public void stateChanged(Horse horse, int state) {
		// ทำต่อให้จบ ขึ้นให้ดูนิดหน่อย ให้พอนึกภาพออก		
		if(state == Horse.DONE_STATE){
			JOptionPane.showMessageDialog(this, horse.getName()+ " is Done");
		}
		
	}


	public static void main(String args[]) {
		try {

			UIManager.setLookAndFeel(new WindowsLookAndFeel());
		} catch (UnsupportedLookAndFeelException ex) {
			ex.printStackTrace();
		}

		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				new HorseRaceFrame().setVisible(true);
			}
		});
	}

	
	private HorsePanel horsePanel1;
	private HorsePanel horsePanel2;
	private HorsePanel horsePanel3;
	private JButton startAllButton;
	private JButton resetAllButton;
	private JButton togglePlayPauseButton;
	private JScrollPane consoleTexAreaScrollPane;
	private JTextArea consoleTextArea;


}
