package horserace;


import java.io.OutputStream;
import javax.swing.JTextArea;
import java.io.*;


public class JTextAreaPrintStream extends PrintStream {
    
    private JTextArea textArea;
    private StringBuffer buffer;
    
    
    public JTextAreaPrintStream(JTextArea area, OutputStream out) {
        super(out);
        textArea = area;
        buffer = new StringBuffer(128);
    }
    
    public void println(String string) {
        synchronized (this) {
            print(string+"\n");
            flush();
        }
        
    }
    
    @Override
    public void flush() {
        super.flush();
        synchronized (this) {
            if(buffer!=null){
                
                textArea.append(buffer.toString());
                textArea.setCaretPosition(textArea.getText().length());
                buffer = null;
            }
        }
    }
    
    public void print(String string) {
        synchronized (this) {
            getBuffer().append(string);
            if(string.indexOf('\n')!=-1)
                flush();
        }
    }
    
    private StringBuffer getBuffer(){
        if(buffer == null){
            buffer = new StringBuffer(128);
        }
        
        return this.buffer;
    }
    
    
}